	ORG	60000
	CALL	DRINI
	CALL	PAGE
	CALL	CORI
	JP	MENU
DRINI	LD	C,128
	LD	B,87
	LD	(POSIT),BC
	RET
DRIVE	CALL	PTRDR
DRI1	HALT
	CALL	KEYDR
	BIT	0,A
	PUSH	AF
	CALL	NZ,DRLE
	POP	AF
	BIT	1,A
	PUSH	AF
	CALL	NZ,DRRI
	POP	AF
	BIT	2,A
	PUSH	AF
	CALL	NZ,DRDO
	POP	AF
	BIT	3,A
	PUSH	AF
	CALL	NZ,DRUP
	POP	AF
	BIT	4,A
	JR	Z,DRI1
	CALL	PTRCL
	LD	BC,(POSIT)
	RET
KEYDR	LD	A,(JOY)
	OR	A
	JR	Z,KEYKB
	IN	A,(31)
	LD	B,A
	AND	31
	LD	A,B
	JP	NZ,JOYCL
KEYKB	LD	BC,57342
	IN	A,(C)
	CPL
	LD	D,A
	AND	2
	RRCA
	LD	E,A
	LD	A,D
	AND	1
	RLCA
	OR	E
	LD	E,A
	LD	B,253
	IN	A,(C)
	CPL
	AND	1
	RLCA
	RLCA
	OR	E
	LD	E,A
	LD	B,251
	IN	A,(C)
	CPL
	AND	1
	RLCA
	RLCA
	RLCA
	OR	E
	LD	E,A
	LD	B,127
	IN	A,(C)
	CPL
	AND	4
	RLCA
	RLCA
	OR	E
	JR	Z,KEYDR
	RET
DRLE	LD	DE,0FF00H
	LD	A,(POSIT)
	OR	A
	RET	Z
	JR	DRSH
DRRI	LD	DE,0100H
	LD	A,(POSIT)
	CP	248
	RET	NC
	JR	DRSH
DRUP	LD	DE,0001H
	LD	A,(POSIT+1)
	CP	191
	RET	NC
	JR	DRSH
DRDO	LD	DE,00FFH
	LD	A,(POSIT+1)
	CP	9
	RET	C
DRSH	PUSH	DE
	CALL	PTRCL
	POP	DE
	LD	HL,(POSIT)
	LD	A,H
	ADD	A,E
	LD	H,A
	LD	A,L
	ADD	A,D
	LD	L,A
	LD	(POSIT),HL
PTRDR	LD	BC,(POSIT)
	LD	IX,BUF16
	LD	DE,PTRGR
	LD	A,8
DR1	PUSH	AF
	PUSH	BC
	LD	A,192
	SUB	B
	LD	B,A
	CALL	22B1H
	LD	C,A
	LD	A,(HL)
	LD	(IX),A
	INC	IX
	INC	HL
	LD	A,(HL)
	LD	(IX),A
	INC	IX
	DEC	HL
	LD	B,C
	LD	A,C
	OR	A
	EX	AF,AF'
	LD	A,(DE)
	INC	DE
	EX	AF,AF'
	LD	A,(DE)
	INC	DE
	JR	Z,DR4
DR2	SRL	A
	EX	AF,AF'
	SCF
	RRA
	EX	AF,AF'
	DJNZ	DR2
	EX	AF,AF'
	AND	(HL)
	LD	B,A
	EX	AF,AF'
	OR	B
	LD	(HL),A
	INC	HL
	LD	A,8
	SUB	C
	LD	B,A
	PUSH	DE
	DEC	DE
	LD	A,(DE)
	EX	AF,AF'
	DEC	DE
	LD	A,(DE)
	EX	AF,AF'
	POP	DE
DR3	SLA	A
	EX	AF,AF'
	SCF
	RLA
	EX	AF,AF'
	DJNZ	DR3
DR4	EX	AF,AF'
	AND	(HL)
	LD	B,A
	EX	AF,AF'
	OR	B
	LD	(HL),A
	POP	BC
	POP	AF
	DEC	B
	DEC	A
	JR	NZ,DR1
	RET
PTRCL	LD	A,8
	LD	IX,BUF16
	LD	BC,(POSIT)
CL1	PUSH	AF
	PUSH	BC
	LD	A,192
	SUB	B
	LD	B,A
	CALL	22B1H
	LD	A,(IX)
	INC	IX
	LD	(HL),A
	INC	HL
	LD	A,(IX)
	INC	IX
	LD	(HL),A
	POP	BC
	POP	AF
	DEC	B
	DEC	A
	JR	NZ,CL1
	RET
BUF16	DEFS	16
PTRGR	DEFB	3,0,3,78H
	DEFB	3,70H,3,70H
	DEFB	1,48H,0,4
	DEFB	0F0H,2,0F8H,0
POSIT	DEFS	2
JOY	DEFB	0
JOYCL	LD	B,A
	AND	2
	RRCA
	LD	C,A
	LD	A,B
	AND	1
	RLCA
	OR	C
	LD	C,A
	LD	A,B
	AND	0FCH
	OR	C
	RET
START	CALL	0D6BH
	LD	A,254
	CALL	1601H
	CALL	DESK
	CALL	CHARS
	CALL	REVRS
	JP	LOOP
DESK	LD	DE,DE1
	LD	BC,DE2-DE1
	CALL	203CH
	LD	BC,1611H
	CALL	PRAT
	LD	DE,FINAM
	LD	BC,10
	CALL	203CH
	LD	HL,18518
	LD	A,(JOY)
	SUB	1
	CCF
	SBC	A,A
	LD	E,8
INVERT	LD	D,A
	LD	C,8
DS1	PUSH	HL
	LD	B,E
DS2	LD	A,D
	XOR	(HL)
	LD	(HL),A
	INC	HL
	DJNZ	DS2
	POP	HL
	INC	H
	DEC	C
	JR	NZ,DS1
	RET
DE1	DEFB	22,2,22
	DEFM	'CLEAR FONT'
	DEFB	22,4,22
	DEFM	'CLEAR CHAR'
	DEFB	22,6,22
	DEFM	'SAVE FONT'
	DEFB	22,8,22
	DEFM	'LOAD FONT'
	DEFB	22,10,22
	DEFM	'JOYSTICK'
	DEFB	22,12,22
	DEFM	'EXIT'
	DEFB	22,14,22
	DEFM	'WIEW FONT'
	DEFB	22,16,22
	DEFM	'FILENAME:'
	DEFB	22,19,22
	DEFM	'<-  *  ->'
DE2
FONT	EQU	54000
ACTCHR	DEFB	0
CHARS	LD	HL,20661
	LD	A,(ACTCHR)
	DEC	A
	CP	255
	JR	NZ,CH1
	LD	A,95
CH1	CALL	CHAR
	CALL	ACTUAL
	LD	HL,20669
	LD	A,(ACTCHR)
	INC	A
	CP	96
	JR	NZ,CHAR
	XOR	A
	JR	CHAR
ACTUAL	LD	HL,20665
	LD	A,(ACTCHR)
CHAR	CALL	CLECH
	EX	DE,HL
	CALL	CHRAD
	LD	C,20
	EX	DE,HL
CHD1	LD	B,3
	PUSH	HL
CHD2	PUSH	BC
	PUSH	HL
	LD	A,(DE)
	LD	B,8
CHD3	RLA
	INC	HL
	INC	HL
	RL	(HL)
	DEC	HL
	RL	(HL)
	DEC	HL
	RL	(HL)
	INC	H
	DJNZ	CHD3
	INC	DE
	POP	HL
	LD	BC,32
	ADD	HL,BC
	POP	BC
	DJNZ	CHD2
	POP	HL
	DEC	C
	JR	NZ,CHD1
	RET
CHRAD	LD	L,A
	LD	H,0
	ADD	HL,HL
	ADD	HL,HL
	LD	B,H
	LD	C,L
	ADD	HL,BC
	ADD	HL,BC
	LD	B,H
	LD	C,L
	ADD	HL,BC
	ADD	HL,BC
	ADD	HL,BC
	ADD	HL,BC
	LD	BC,FONT
	ADD	HL,BC
	RET
REVRS	LD	A,(ACTCHR)
	CALL	CHRAD
	EX	DE,HL
	LD	HL,22528
	LD	B,20
	HALT
REV1	PUSH	BC
	LD	C,3
	PUSH	HL
REV2	LD	A,(DE)
	LD	B,8
REV3	RLA
	PUSH	AF
	LD	A,38H
	JR	NC,REV4
	LD	A,7
REV4	LD	(HL),A
	PUSH	BC
	LD	BC,32
	ADD	HL,BC
	POP	BC
	POP	AF
	DJNZ	REV3
	INC	DE
	DEC	C
	JR	NZ,REV2
	POP	HL
	POP	BC
	INC	HL
	DJNZ	REV1
	RET
LOOP	CALL	GETFN
	LD	L,A
	LD	H,0
	ADD	HL,HL
	LD	DE,FNTAB
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	LD	DE,LOOP
	PUSH	DE
	JP	(HL)
FNTAB	DEFW	FILE
	DEFW	WIEW
	DEFW	EXIT
	DEFW	JOYON
	DEFW	LOAD
	DEFW	SAVE
	DEFW	CLCHR
	DEFW	CLFON
	DEFW	POINT
	DEFW	BACK
	DEFW	FWD
GETFN	CALL	DRIVE
	LD	A,8
TIME	HALT
	DEC	A
	JR	NZ,TIME
	LD	A,C
	CP	160
	LD	A,8
	RET	C
	LD	A,C
	CP	168
	JR	C,BADFN
	LD	A,B
	CP	56
	JR	C,LOW
	CP	176
	JR	NC,BADFN
	SUB	56
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	RET	NC
BADFN	XOR	A
	OUT	(254),A
	HALT
	HALT
	LD	A,7
	OUT	(254),A
	JR	GETFN
JOYON	LD	A,(JOY)
	CPL
	LD	(JOY),A
	JP	DESK
EXIT	POP	HL
	RET
LOW	CP	32
	JR	C,BADFN
	CP	40
	JR	NC,BADFN
	LD	A,C
	CP	192
	LD	A,9
	RET	C
	LD	A,C
	CP	232
	JR	C,BADFN
	CP	248
	JR	NC,BADFN
	LD	A,10
	RET
POINT	LD	BC,(POSIT)
	LD	A,192
	SUB	B
	LD	B,A
	SRL	B
	SRL	B
	SRL	B
	SRL	C
	SRL	C
	SRL	C
	LD	HL,22528
	LD	DE,32
	LD	A,B
	OR	A
	JR	Z,POX
PO1	ADD	HL,DE
	DJNZ	PO1
POX	ADD	HL,BC
	LD	A,3FH
	XOR	(HL)
	LD	(HL),A
	CALL	COMPL
	JP	ACTUAL
COMPL	LD	A,(ACTCHR)
	CALL	CHRAD
	EX	DE,HL
	LD	HL,22528
	LD	B,20
COM1	PUSH	BC
	PUSH	HL
	LD	C,3
COM3	XOR	A
	LD	B,8
COM4	PUSH	BC
	LD	C,A
	LD	A,(HL)
	SUB	8
	LD	A,C
	RLA
	LD	BC,32
	ADD	HL,BC
	POP	BC
	DJNZ	COM4
	LD	(DE),A
	INC	DE
	DEC	C
	JR	NZ,COM3
	POP	HL
	POP	BC
	INC	HL
	DJNZ	COM1
	RET
CLECH	PUSH	HL
	LD	C,3
CLE1	LD	B,8
	PUSH	HL
CLE2	LD	(HL),0
	INC	HL
	LD	(HL),0
	INC	HL
	LD	(HL),0
	DEC	HL
	DEC	HL
	INC	H
	DJNZ	CLE2
	POP	HL
	LD	DE,32
	ADD	HL,DE
	DEC	C
	JR	NZ,CLE1
	POP	HL
	RET
CLFON	XOR	A
	OUT	(254),A
	CALL	GETFN
	LD	B,A
	LD	A,7
	OUT	(254),A
	LD	A,B
	CP	7
	RET	NZ
	LD	HL,FONT
	LD	BC,5760
CF1	LD	(HL),0
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,CF1
	CALL	REVRS
	JP	ACTUAL
CLCHR	XOR	A
	OUT	(254),A
	CALL	GETFN
	LD	B,A
	LD	A,7
	OUT	(254),A
	LD	A,B
	CP	6
	RET	NZ
	LD	A,(ACTCHR)
	CALL	CHRAD
	LD	B,60
CC1	LD	(HL),0
	INC	HL
	DJNZ	CC1
	CALL	REVRS
	JP	ACTUAL
FILE	LD	HL,23094
	LD	DE,FINAM
	LD	BC,1611H
FI1	LD	(HL),120
	CALL	KEYIN
	LD	(HL),56
	CP	13
	RET	Z
	CP	8
	JP	Z,FILEF
	CP	9
	JR	Z,FIRIG
	PUSH	AF
	CALL	PRAT
	POP	AF
	LD	(DE),A
	RST	16
FIRIG	LD	A,B
	CP	31
	JR	Z,FI1
	INC	B
	INC	HL
	INC	DE
	JR	FI1
FILEF	LD	A,B
	CP	22
	JR	Z,FI1
	DEC	B
	DEC	HL
	DEC	DE
	JR	FI1
HEAD	DEFB	3
FINAM	DEFM	'          '
	DEFW	5760
	DEFW	54000
	DEFW	0
PRAT	LD	A,22
	RST	16
	LD	A,C
	RST	16
	LD	A,B
	RST	16
	RET
KEYIN	LD	(IY-50),0
KE1	LD	A,(23560)
	OR	A
	JR	Z,KE1
	CP	6
	JP	NZ,CONVK
	LD	A,(23658)
	XOR	8
	LD	(23658),A
	JR	KEYIN
SAVE	LD	IX,HEAD
	LD	DE,17
	XOR	A
	CALL	04C2H
	LD	B,50
SA1	HALT
	DJNZ	SA1
	LD	IX,FONT
	LD	DE,5760
	LD	A,255
	JP	04C2H
LOAD	LD	BC,1611H
	CALL	PRAT
	LD	DE,LO1
	LD	BC,LO2-LO1
	CALL	203CH
LOA1	LD	IX,HEAD
	LD	DE,17
	XOR	A
	SCF
	CALL	0556H
	JR	NC,LOA1
	LD	DE,FINAM
	LD	BC,1611H
	CALL	PRAT
	LD	BC,10
	CALL	203CH
	LD	IX,FONT
	LD	DE,5760
	LD	A,255
	SCF
	CALL	0556H
	CALL	REVRS
	JP	ACTUAL
LO1	DEFM	'SEARCHING '
LO2
BACK	LD	HL,ACTCHR
	LD	A,(HL)
	OR	A
	RET	Z
	DEC	(HL)
	CALL	REVRS
	JP	CHARS
FWD	LD	HL,ACTCHR
	LD	A,(HL)
	CP	95
	RET	Z
	INC	(HL)
	CALL	REVRS
	JP	CHARS
WIEW	XOR	A
	CALL	WIEW1
	LD	A,48
	CALL	WIEW1
	POP	HL
	JP	START
WIEW1	PUSH	AF
	CALL	0D6BH
	POP	AF
	LD	B,192
WIEW2	LD	C,0
WIEW3	PUSH	BC
	PUSH	AF
	LD	A,192
	SUB	B
	LD	B,A
	CALL	22B1H
	POP	AF
	PUSH	AF
	CALL	CHAR
	POP	AF
	POP	BC
	INC	A
	LD	D,A
	LD	A,C
	ADD	A,32
	LD	C,A
	LD	A,D
	JR	NZ,WIEW3
	LD	A,B
	SUB	32
	LD	B,A
	LD	A,D
	JR	NZ,WIEW2
	JP	DRIVE
MENU	CALL	0D6BH
	LD	A,254
	CALL	1601H
METXT	LD	DE,ME1
	LD	BC,ME2-ME1
	CALL	203CH
	LD	A,(JOY)
	SUB	1
	CCF
	SBC	A,A
	LD	HL,20512
	LD	D,A
	LD	E,8
	CALL	INVERT
	LD	A,(DENS)
	SUB	1
	SBC	A,A
	LD	HL,20502
	LD	E,6
	LD	D,A
	CALL	INVERT
	LD	A,(DENS)
	SUB	1
	CCF
	SBC	A,A
	LD	HL,20534
	LD	D,A
	CALL	INVERT
	LD	A,(INTER)
	SUB	1
	SBC	A,A
	LD	HL,20598
	LD	D,A
	LD	E,10
	CALL	INVERT
	LD	A,(INTER)
	OR	A
	JR	Z,NOIN
	SUB	2
	SBC	A,A
	LD	HL,20630
	LD	D,A
	CALL	INVERT
	LD	A,(INTER)
	CP	1
	JR	Z,NOIN
	SUB	3
	SBC	A,A
	LD	HL,20662
	LD	D,A
	CALL	INVERT
NOIN	CALL	ACTSET
MLOOP	CALL	GETMI
	LD	L,A
	LD	H,0
	ADD	HL,HL
	LD	DE,MTAB
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	HL,MLOOP
	PUSH	HL
	PUSH	DE
	RET
ME1	DEFB	22,0,11
	DEFM	'SUPERPRINT'
	DEFB	13
	DEFM	'(C) 1989 '
	DEFM	'MJSOFT '
	DEFM	'SYSTEM '
	DEFM	'SOFTWARE'
	DEFB	13,13
	DEFM	'EDIT'
	DEFB	13,13
	DEFM	'PRINT'
	DEFB	13,13
	DEFM	'TEXT'
	DEFB	13,13
	DEFM	'LOAD'
	DEFB	13,13
	DEFM	'SAVE'
	DEFB	13,13
	DEFM	'EXIT'
	DEFB	13,13
	DEFM	'CENTRE'
	DEFB	13,13
	DEFM	'JOYSTICK'
	DEFB	13,13
	DEFM	'INSTALL'
	DEFB	22,3,9
	DEFM	'X-POSITION.'
	DEFM	'..000 PTS +-'
	DEFB	22,4,9
	DEFM	'Y-POSITION.'
	DEFM	'..000 LNS +-'
	DEFB	22,5,9
	DEFM	'X-MAGNIFY..'
	DEFM	'..000 x   +-'
	DEFB	22,6,9
	DEFM	'Y-MAGNIFY..'
	DEFM	'..000 x   +-'
	DEFB	22,7,9
	DEFM	'X-SPACING..'
	DEFM	'..000 PTS +-'
	DEFB	22,8,9
	DEFM	'Y-SPACING..'
	DEFM	'..000 PTS +-'
	DEFB	22,9,9
	DEFM	'X-AXIS ADD.'
	DEFM	'..000 PTS +-'
	DEFB	22,10,9
	DEFM	'CHAR-SPACIN'
	DEFM	'G.000 PTS +-'
	DEFB	22,11,9
	DEFM	'CHAR-WIDTH.'
	DEFM	'..000 ELS +-'
	DEFB	22,13,9
	DEFM	'MAX. LENGTH'
	DEFM	'..000 CHARS'
	DEFB	22,14,9
	DEFM	'TEXT LENGTH'
	DEFM	'..000 CHARS'
	DEFB	22,16,9
	DEFM	'DENSITY....'
	DEFM	'..SINGLE..60'
	DEFB	22,17,22
	DEFM	'DOUBLE.120'
	DEFB	22,19,9
	DEFM	'INTERFACE..'
	DEFM	'..CENTRONICS'
	DEFB	22,20,22
	DEFM	'SERIAL 128'
	DEFB	22,21,22
	DEFM	'USER      '
ME2
DENS	DEFB	0
INTER	DEFB	0
GETMI	CALL	DRIVE
	LD	A,8
GMI1	HALT
	DEC	A
	JR	NZ,GMI1
	LD	A,B
	CP	168
	JR	NC,GMIE
	LD	A,C
	CP	64
	JR	NC,GMIS
	LD	A,B
	SUB	32
	JR	C,GMIE
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	JR	C,GMIE
	LD	B,A
	LD	A,8
	SUB	B
	RET
GMIE	XOR	A
	OUT	(254),A
	HALT
	HALT
	LD	A,7
	OUT	(254),A
	JR	GETMI
GMIS	LD	A,B
	CP	96
	JR	NC,GMIAS
	CP	64
	JR	NC,GMIE
	CP	48
	JR	NC,GMISD
	CP	40
	JR	NC,GMIE
	CP	16
	JR	C,GMIE
	LD	A,C
	CP	176
	JR	C,GMIE
	LD	A,B
	SUB	16
	SRL	A
	SRL	A
	SRL	A
	LD	B,A
	LD	A,2
	SUB	B
	ADD	A,29
	RET
GMIAS	LD	A,C
	SUB	240
	JR	C,GMIE
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	SBC	A,A
	AND	9
	ADD	A,9
	LD	D,A
	LD	A,B
	SUB	96
	SRL	A
	SRL	A
	SRL	A
	LD	B,A
	LD	A,8
	SUB	B
	ADD	A,D
	RET
GMISD	LD	A,C
	CP	176
	JR	C,GMIE
	CP	224
	JR	NC,GMIE
	LD	A,B
	SUB	48
	SRL	A
	SRL	A
	SRL	A
	XOR	1
	ADD	A,27
	RET
MTAB	DEFW	EDIT,PRINT
	DEFW	TEXT,LOADM
	DEFW	SAVE,QUIT
	DEFW	CENTR,JOYST
	DEFW	INST,AXP
	DEFW	AYP,AXM,AYM,AXS
	DEFW	AYS,AXA,ACS,ACW
	DEFW	SXP,SYP,SXM,SYM
	DEFW	SXS,SYS,SXA,SCS
	DEFW	SCW,DENN
	DEFW	DEND,INTC
	DEFW	INTS,INTI
EDIT	CALL	START
	POP	HL
	JP	MENU
QUIT	LD	A,16
	LD	BC,32765
	OUT	(C),A
	RST	8
	DEFB	255
DENN	XOR	A
	LD	(DENS),A
	LD	HL,384
	LD	(PPL),HL
	JP	METXT
DEND	LD	A,1
	LD	(DENS),A
	LD	HL,768
	LD	(PPL),HL
	JP	METXT
INTC	XOR	A
INTE	LD	(INTER),A
	JP	METXT
INTS	LD	A,1
	JR	INTE
INTI	LD	A,2
	JR	INTE
JOYST	LD	A,(JOY)
	CPL
	LD	(JOY),A
	POP	HL
	JP	METXT
DISPAR	LD	IX,VARS
	LD	BC,1603H
	LD	A,9
AS1	PUSH	BC
	PUSH	AF
	CALL	VALUE
	POP	AF
	POP	BC
	INC	C
	DEC	A
	JR	NZ,AS1
	LD	HL,(MAXLEN)
	INC	C
	CALL	PRVAL
	LD	HL,(TEXLEN)
	INC	C
	JR	PRVAL
VALUE	LD	L,(IX)
	INC	IX
	LD	H,(IX)
	INC	IX
	LD	A,H
	AND	128
	JR	Z,PRVAL
	LD	A,H
	CPL
	LD	H,A
	LD	A,L
	CPL
	LD	L,A
	INC	HL
	CALL	PRAT
	LD	A,'-'
	RST	16
	JR	PV1
PRVAL	CALL	PRAT
	LD	DE,100
	CALL	PR1
PV1	LD	DE,10
	CALL	PR1
	LD	A,L
	JR	PR2
PR1	LD	A,255
PR0	INC	A
	AND	A
	SBC	HL,DE
	JR	NC,PR0
	ADD	HL,DE
PR2	ADD	A,'0'
	RST	16
	RET
VARS	DEFW	0,0
	DEFW	1,1
	DEFW	0,0
	DEFW	0,0
	DEFW	20
TEXLEN	DEFW	0
MAXLEN	DEFW	16
PPL	DEFW	384
ACTSET	CALL	CALC
	LD	(MAXLEN),HL
	JP	DISPAR
CALC	LD	IX,VARS
	LD	L,(IX+4)
	LD	E,(IX+8)
	LD	H,0
	LD	D,0
	ADD	HL,DE
	LD	B,(IX+16)
	LD	DE,0
	EX	DE,HL
CA1	ADD	HL,DE
	DJNZ	CA1
	LD	E,(IX+14)
	LD	D,(IX+15)
	ADD	HL,DE
	PUSH	HL
	LD	L,(IX+6)
	LD	E,(IX+10)
	LD	H,0
	LD	D,0
	ADD	HL,DE
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	D,H
	LD	E,L
	ADD	HL,HL
	ADD	HL,DE
	EX	DE,HL
	LD	HL,0
	LD	A,(IX+12)
	BIT	7,A
	JR	Z,CA2
	NEG
CA2	LD	B,A
	OR	A
	JR	Z,CA4
CA3	ADD	HL,DE
	DJNZ	CA3
CA4	EX	DE,HL
	LD	HL,(PPL)
	AND	A
	SBC	HL,DE
	LD	E,(IX)
	LD	D,(IX+1)
	AND	A
	SBC	HL,DE
	POP	DE
	LD	(PLIN),HL
	LD	(CWIP),DE
	LD	A,255
CA5	INC	A
	AND	A
	SBC	HL,DE
	JR	NC,CA5
	LD	L,A
	LD	H,0
	RET
AXP	LD	DE,(PPL)
	DEC	DE
	LD	BC,0
	JR	CADD
AYP	LD	DE,9
	LD	BC,2
	JR	CADD
AXM	LD	DE,48
	LD	BC,4
	JR	CADD
AYM	LD	DE,48
	LD	BC,6
	JR	CADD
AXS	LD	DE,9
	LD	BC,8
	JR	CADD
AYS	LD	DE,9
	LD	BC,10
	JR	CADD
AXA	LD	DE,2
	LD	BC,12
	JR	CADD
ACS	LD	DE,29
	LD	BC,14
	JR	CADD
ACW	LD	DE,20
	LD	BC,16
CADD	LD	HL,1
	JR	CHG
SXP	LD	DE,0
	LD	BC,0
	JR	CSUB
SYP	LD	DE,0
	LD	BC,2
	JR	CSUB
SXM	LD	DE,1
	LD	BC,4
	JR	CSUB
SYM	LD	DE,1
	LD	BC,6
	JR	CSUB
SXS	LD	DE,0
	LD	BC,8
	JR	CSUB
SYS	LD	DE,0
	LD	BC,10
	JR	CSUB
SXA	LD	DE,65534
	LD	BC,12
	JR	CSUB
SCS	LD	DE,0
	LD	BC,14
	JR	CSUB
SCW	LD	DE,8
	LD	BC,16
CSUB	LD	HL,65535
CHG	LD	IX,VARS
	ADD	IX,BC
	LD	C,(IX)
	LD	B,(IX+1)
	EX	DE,HL
	AND	A
	SBC	HL,BC
	LD	A,H
	OR	L
	RET	Z
	EX	DE,HL
	ADD	HL,BC
	PUSH	BC
	LD	(IX),L
	LD	(IX+1),H
	PUSH	IX
	CALL	CALC
	POP	IX
	LD	DE,(TEXLEN)
	LD	A,D
	OR	E
	JR	NZ,CHG1
	INC	DE
CHG1	AND	A
	SBC	HL,DE
	POP	BC
	JP	NC,ACTSET
	LD	(IX),C
	LD	(IX+1),B
	RET
INST	CALL	0D6BH
	LD	A,254
	CALL	1601H
	LD	DE,INS1
	LD	BC,INS2-INS1
	CALL	203CH
	CALL	INNUM
LIF	CALL	GETIF
	LD	HL,IFTAB
	LD	E,A
	LD	D,0
	ADD	HL,DE
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	HL,LIF
	PUSH	HL
	PUSH	DE
	RET
INS1	DEFB	22,0,12
	DEFM	'INSTALL'
	DEFB	22,1,12
	DEFM	'PRINTER'
	DEFB	22,2,12
	DEFM	'ROUTINE'
	DEFB	22,2,23
	DEFM	'ONLY FOR'
	DEFB	22,3,23
	DEFM	'EPSON FX'
	DEFB	22,4,23
	DEFM	'PRINTERS'
	DEFB	22,4,1
	DEFM	'INIT AT..'
	DEFM	'.....#0000'
	DEFB	22,7,1
	DEFM	'READY=Z A'
	DEFM	'T....#0000'
	DEFB	22,10,1
	DEFM	'WRITE AT.'
	DEFM	'.....#0000'
	DEFB	22,5,16
	DEFM	'+-+-'
	DEFB	22,8,16
	DEFM	'+-+-'
	DEFB	22,11,16
	DEFM	'+-+-'
	DEFB	22,7,23
	DEFM	'RETURN'
	DEFB	22,9,23
	DEFM	'STANDART'
	DEFB	22,13,1
	DEFM	'ROUTINES CA'
	DEFM	'N MODIFY AN'
	DEFM	'Y REGIS-'
	DEFB	13
	DEFM	' TER WITHOU'
	DEFM	'T IY, SP A'
	DEFM	'ND IX'
	DEFB	13,13
	DEFM	' (IY CONTAI'
	DEFM	'NS #5C3A )'
	DEFB	13,13
INS2
GETIF	CALL	DRIVE
	LD	A,8
GIF1	HALT
	DEC	A
	JR	NZ,GIF1
	LD	A,B
	CP	96
	JR	C,GIFE
	CP	152
	JR	NC,GIFE
	LD	A,C
	CP	128
	JR	C,GIFE
	CP	160
	JR	C,GIFM
	CP	184
	JR	C,GIFE
	CP	248
	JR	C,GIFF
GIFE	XOR	A
	OUT	(254),A
	HALT
	HALT
	LD	A,7
	OUT	(254),A
	JR	GETIF
GIFM	LD	A,B
	SUB	96
	SRL	A
	SRL	A
	SRL	A
	JR	Z,GIF2
	LD	B,0
GIF3	INC	B
	SUB	3
	JR	C,GIFE
	JR	NZ,GIF3
	LD	A,B
GIF2	ADD	A,A
	ADD	A,A
	LD	B,A
	LD	A,C
	SUB	128
	SRL	A
	SRL	A
	SRL	A
	ADD	A,B
	RET
GIFF	LD	A,B
	SUB	112
	JR	C,GIFE
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	JR	C,GIFE
	CP	2
	JR	NC,GIFE
	ADD	A,12
	RET
IFTAB	DEFW	AWAH,SWAH
	DEFW	AWAL,SWAL
	DEFW	ARAH,SRAH
	DEFW	ARAL,SRAL
	DEFW	AIAH,SIAH
	DEFW	AIAL,SIAL
	DEFW	STAND,ZPET
ZPET	POP	HL
	POP	HL
	JP	MENU
STAND	LD	HL,32768
	LD	(RINIT),HL
	INC	H
	LD	(RREADY),HL
	INC	H
	LD	(RPRINT),HL
	JP	INNUM
INNUM	LD	BC,1004H
	LD	HL,(RINIT)
	CALL	HEXNR
	LD	BC,1007H
	LD	HL,(RREADY)
	CALL	HEXNR
	LD	BC,100AH
	LD	HL,(RPRINT)
HEXNR	CALL	PRAT
	LD	A,H
	CALL	HEX1
	LD	A,L
HEX1	PUSH	AF
	RRCA
	RRCA
	RRCA
	RRCA
	CALL	HEX2
	POP	AF
HEX2	AND	15
	CP	10
	JR	C,HEX3
	ADD	A,7
HEX3	ADD	A,'0'
	RST	16
	RET
RINIT	DEFW	32768
RREADY	DEFW	8100H
RPRINT	DEFW	8200H
AWAH	LD	C,5
	JR	INCR
AWAL	LD	C,4
	JR	INCR
AIAH	LD	C,1
	JR	INCR
AIAL	LD	C,0
	JR	INCR
ARAH	LD	C,3
	JR	INCR
ARAL	LD	C,2
INCR	LD	B,0
	LD	HL,RINIT
	ADD	HL,BC
	LD	A,(HL)
	CP	255
	RET	Z
	INC	(HL)
	JP	INNUM
SIAH	LD	C,1
	JR	DECR
SIAL	LD	C,0
	JR	DECR
SRAH	LD	C,3
	JR	DECR
SRAL	LD	C,2
	JR	DECR
SWAH	LD	C,5
	JR	DECR
SWAL	LD	C,4
DECR	LD	HL,RINIT
	LD	B,0
	ADD	HL,BC
	LD	A,(HL)
	OR	A
	RET	Z
	DEC	(HL)
	JP	INNUM
TEXT	CALL	0D6BH
	LD	A,254
	CALL	1601H
	LD	DE,TEE1
	LD	BC,TEE2-TEE1
	CALL	203CH
	LD	BC,(MAXLEN)
	CALL	2D2BH
	CALL	2DE3H
	LD	HL,BUF
	LD	DE,(MAXLEN)
	CALL	TEDIT
	POP	HL
	JP	MENU
TEE1	DEFM	'ENTER TE'
	DEFM	'XT, LENGTH '
	DEFM	'MAX. '
TEE2
TEDIT	LD	A,13
	RST	16
	LD	A,13
	RST	16
	LD	D,0
TED1	LD	A,'_'
	RST	16
	LD	A,8
	RST	16
	CALL	KEYIN
	CP	13
	JR	Z,TED13
	CP	12
	JR	Z,TED12
	PUSH	HL
	LD	H,A
	LD	A,D
	CP	E
	LD	A,H
	POP	HL
	JR	Z,TED1
	INC	D
	LD	(HL),A
	INC	HL
	RST	16
	JR	TED1
TED12	LD	A,D
	OR	A
	JR	Z,TED1
	LD	A,32
	RST	16
	LD	A,8
	RST	16
	LD	A,8
	RST	16
	DEC	D
	DEC	HL
	JR	TED1
TED13	LD	A,13
	LD	(HL),A
	LD	L,D
	LD	H,0
	LD	(TEXLEN),HL
	RET
BUF	DEFS	256
CWIP	DEFW	0
PLIN	DEFW	0
CENTR	LD	HL,0
	LD	DE,(CWIP)
	LD	A,(TEXLEN)
	OR	A
	JR	Z,CEN1
	LD	B,A
CEN0	ADD	HL,DE
	DJNZ	CEN0
CEN1	EX	DE,HL
	LD	HL,(PLIN)
	AND	A
	SBC	HL,DE
	SRL	H
	RR	L
	LD	(VARS),HL
	CALL	CALC
	LD	(MAXLEN),HL
	JP	DISPAR
PRINT	LD	HL,(TEXLEN)
	LD	DE,(MAXLEN)
	AND	A
	EX	DE,HL
	SBC	HL,DE
	RET	C
	LD	HL,(VARS)
	PUSH	HL
	CALL	PINIT
	LD	IX,VARS
	LD	A,(IX+2)
	OR	A
	JR	Z,PO2
	LD	B,A
PX1	CALL	CRLF
	DJNZ	PX1
PO2	CALL	CLBUF
	EXX
	LD	C,0
	EXX
PRTHI	EXX
	LD	D,128
	EXX
PRLIN	EXX
	LD	B,(IX+6)
	EXX
PRYMG	EXX
	LD	HL,BUF
	EXX
PRCHR	EXX
	LD	A,(HL)
	INC	HL
	EXX
	CP	13
	JR	Z,PREOL
	SUB	32
	CALL	CHRAD
	EXX
	LD	A,C
	EXX
	LD	C,A
	LD	B,0
	ADD	HL,BC
	LD	C,(IX+16)
PRCPT	LD	B,(IX+4)
PRXMG	EXX
	LD	A,D
	EXX
	AND	(HL)
	CALL	CONVB
	EX	DE,HL
	OR	(HL)
	LD	(HL),A
	EX	DE,HL
	INC	DE
	DJNZ	PRXMG
	LD	A,(IX+8)
	OR	A
	JR	Z,PRNXS
	LD	B,A
PRXSP	INC	DE
	DJNZ	PRXSP
PRNXS	INC	HL
	INC	HL
	INC	HL
	DEC	C
	JR	NZ,PRCPT
	LD	B,(IX+14)
	LD	A,B
	OR	A
	JR	Z,PRNCS
PRCHS	INC	DE
	DJNZ	PRCHS
PRNCS	JR	PRCHR
PREOL	LD	L,(IX)
	LD	H,(IX+1)
	LD	C,(IX+12)
	LD	A,C
	RLA
	SBC	A,A
	LD	B,A
	ADD	HL,BC
	LD	(IX),L
	LD	(IX+1),H
	CALL	NXTLIN
	EXX
	DEC	B
	EXX
	JR	NZ,PRYMG
	LD	A,(IX+10)
	OR	A
	LD	B,A
	JR	Z,PRNYS
PRYSP	PUSH	BC
	CALL	NXTLIN
	POP	BC
	DJNZ	PRYSP
PRNYS	EXX
	RRC	D
	EXX
	JP	NC,PRLIN
	EXX
	INC	C
	LD	A,C
	EXX
	CP	3
	JP	C,PRTHI
	POP	HL
	LD	(VARS),HL
	POP	HL
	JP	MENU
NXTLIN	EXX
	INC	E
	LD	A,E
	EXX
	CP	8
	JR	C,CBEND
	PUSH	BC
	PUSH	DE
	PUSH	HL
	CALL	GMODE
	LD	HL,16384
	LD	BC,(PPL)
COPY1	LD	A,(HL)
	CALL	PPRINT
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,COPY1
	CALL	CRLF
	POP	HL
	POP	DE
	POP	BC
CLBUF	PUSH	HL
	LD	HL,16384
	PUSH	BC
	LD	BC,(PPL)
CBUF1	LD	(HL),0
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,CBUF1
	POP	BC
	POP	HL
	EXX
	LD	E,0
	EXX
CBEND	PUSH	HL
	LD	HL,(VARS)
	LD	DE,16384
	ADD	HL,DE
	EX	DE,HL
	POP	HL
	RET
PINIT	LD	A,(INTER)
	LD	L,A
	LD	H,0
	ADD	HL,HL
	LD	DE,INTAB
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	PUSH	DE
	RET
INTAB	DEFW	ICHNP
	DEFW	I128
	DEFW	IINST
ICHNP	LD	HL,CHPIN
	LD	DE,CHPPR
	LD	BC,RT
	JR	INSTPR
I128	LD	HL,RT
	LD	DE,S12PR
	LD	BC,RT
	JR	INSTPR
IINST	LD	HL,(RINIT)
	LD	DE,(RPRINT)
	LD	BC,(RREADY)
INSTPR	LD	(AREADY),BC
	LD	(APRINT),DE
	PUSH	HL
	RET
AREADY	DEFS	2
APRINT	DEFS	2
CHPIN	LD	A,3
	JP	1601H
CHPPR	RST	16
	RET
S12PR	LD	E,A
	DI
	XOR	A
	LD	BC,32765
	OUT	(C),A
	LD	A,E
	CALL	08C2H
	LD	A,17
	LD	BC,32765
	OUT	(C),A
	EI
	RET
RT	XOR	A
	RET
PPRINT	PUSH	BC
	PUSH	DE
	PUSH	HL
	PUSH	AF
	EXX
	PUSH	BC
	PUSH	DE
	PUSH	HL
	EXX
	PUSH	AF
	PUSH	IX
PPR1	CALL	PREADY
	JR	NZ,PPR1
	POP	IX
	POP	AF
	PUSH	IX
	CALL	BPRINT
	POP	IX
	EXX
	POP	HL
	POP	DE
	POP	BC
	EXX
	POP	AF
	POP	HL
	POP	DE
	POP	BC
	RET
BPRINT	LD	HL,(APRINT)
	PUSH	HL
	RET
PREADY	LD	HL,(AREADY)
	PUSH	HL
	RET
CRLF	LD	A,13
	CALL	PPRINT
	LD	A,10
	JP	PPRINT
GMODE	LD	A,27
	CALL	PPRINT
	LD	A,'A'
	CALL	PPRINT 
	LD	A,8
	CALL	PPRINT
	LD	A,27
	CALL	PPRINT
	LD	A,(DENS)
	ADD	A,'K'
	CALL	PPRINT
	LD	HL,(PPL)
	LD	A,L
	CALL	PPRINT
	LD	A,H
	JP	PPRINT
CONVB	PUSH	BC
	LD	C,A
	EXX
	LD	A,D
	EXX
COB1	RLA
	JR	C,COB2
	SLA	C
	JR	COB1
COB2	EXX
	LD	A,E
	EXX
	OR	A
	JR	Z,COB4
	LD	B,A
COB3	SRL	C
	DJNZ	COB3
COB4	LD	A,C
	POP	BC
	RET
COR	XOR	A
COR1	PUSH	AF
	PUSH	AF
	CALL	CHRAD
	POP	AF
	PUSH	HL
	LD	L,A
	LD	H,0
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	BC,3D00H
	ADD	HL,BC
	LD	DE,16384
	LD	BC,8
	LDIR
	LD	HL,16384
	LD	B,8
CORA	SLA	(HL)
	INC	HL
	DJNZ	CORA
	LD	DE,16384
	POP	HL
	PUSH	HL
	LD	B,60
CORB	LD	(HL),0
	INC	HL
	DJNZ	CORB
	POP	HL
	LD	C,6
CORC	LD	B,3
CORD	PUSH	BC
	LD	C,8
	LD	E,7
CORE	LD	B,3
CORF	LD	A,(DE)
	AND	128
	RLA
	RR	(HL)
	INC	HL
	RR	(HL)
	INC	HL
	RR	(HL)
	DEC	HL
	DEC	HL
	DJNZ	CORF
	DEC	E
	DEC	C
	JR	NZ,CORE
	INC	HL
	INC	HL
	INC	HL
	POP	BC
	DJNZ	CORD
	PUSH	HL
	LD	HL,16384
	LD	B,8
CORG	SLA	(HL)
	INC	HL
	DJNZ	CORG
	POP	HL
	DEC	C
	JR	NZ,CORC
	POP	AF
	INC	A
	CP	96
	JR	C,COR1
	RET
PAGE	LD	HL,60000
	LD	BC,5536
	LD	DE,16384
	LDIR
	LD	HL,PAGR
	LD	DE,5800H
	LD	BC,PAG-PAGR
	LDIR
	JP	5800H
PAGR	LD	BC,32765
	LD	A,17
	OUT	(C),A
	LD	HL,16384
	LD	DE,60000
	LD	BC,5536
	LDIR
	RET
PAG
LOADM	CALL	LOAD
	POP	HL
	JP	MENU
CONVK	CP	128
	RET	C
	CP	226
	JR	Z,KBVLN
	CP	195
	JR	Z,KBSVI
	CP	205
	JR	Z,KBOBR
	CP	204
	JR	Z,KBSLO
	CP	203
	JR	Z,KBSLZ
	CP	198
	JR	Z,KBHRO
	CP	197
	RET	NZ
	LD	A,']'
	RET
KBVLN	LD	A,'~'
	RET
KBSVI	LD	A,'|'
	RET
KBOBR	LD	A,'\'
	RET
KBSLO	LD	A,'{'
	RET
KBSLZ	LD	A,'}'
	RET
KBHRO	LD	A,'['
	RET
CORI	CALL	0D6BH
	LD	A,254
	CALL	1601H
	LD	DE,CRA1
	LD	BC,CRA2-CRA1
	CALL	203CH
CRAA	CALL	DRIVE
	LD	A,B
	SUB	176
	JR	C,CRAA
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	JP	C,COR
	RET
CRA1	DEFM	'COPY ROM'
	DEFB	13
	DEFM	'OLD FONT'
CRA2
